<?php

namespace ThurData\Servers\KerioEmail\Core\Interfaces;

/**
 *
 * @autor ThurData <info@thurdata.ch>
 */
interface CacheManagerInterface
{
    /**
     * @param string $key
     * @return $this
     * @throws \ThurData\Servers\KerioEmail\Core\HandlerError\Exceptions\MGModuleException
     */
    public function setKey($key = 'default');
    
    /**
     * @return string
     */
    public function getKey();
    
    /**
     * @param mixed $data
     * @return $this
     */
    public function setData($data = null);
    
    /**
     * @return mixed
     * @throws \ThurData\Servers\KerioEmail\Core\HandlerError\Exceptions\MGModuleException
     */
    public function getData();
    
    /**
     * @return $this
     * @throws \ThurData\Servers\KerioEmail\Core\HandlerError\Exceptions\MGModuleException
     */
    public function save();
    
    /**
     * @return $this
     * @throws \ThurData\Servers\KerioEmail\Core\HandlerError\Exceptions\MGModuleException
     */
    public function remove();
    
     /**
     * @return $this
     * @throws \ThurData\Servers\KerioEmail\Core\HandlerError\Exceptions\MGModuleException
     */
    public function clearAll();
    
    /**
     * @return type
     * @throws \ThurData\Servers\KerioEmail\Core\HandlerError\Exceptions\MGModuleException
     */
    public function exist();
}
